import React, { Component } from 'react'
import { render } from 'react-dom'

import notifyResize, { NotifyResize } from './src'

class Box extends Component {
  constructor(props){
    super(props)

    this.state = {
      width: 100,
      height: 100
    }
  }
  render(){
    return <div 
        ref="target"
        style={{
        position: 'absolute',
        width: '100%',
        height: '100%',
        top: 0,
        left: 0,
        background: 'red'
      }}
    >
      {this.props.resizeTool}
    
      <div style={{
        position: 'absolute',
        top: 0,
        left: 0,
        width: this.state.width,
        height: this.state.height,
        background: 'rgb(68, 90, 214)'
      }} />
    </div>
  }

  onResize(){
    this.setState({
      width: this.refs.target.offsetWidth,
      height: this.refs.target.offsetHeight
    })
  }
}

const NotifiedBox = notifyResize(Box)

class App extends Component {

  constructor(props){
    super(props)

    this.state = {
      width: 200,
      height: 200
    }
  }

  render(){
    return <div>
      <button onClick={() => {
        this.setState({
          width: this.state.width + 20,
          height: this.state.height + 20,
        })
      }}>More</button>
      <button onClick={() => {
        this.setState({
          width: this.state.width - 20,
          height: this.state.height - 20,
        })
      }}>Less</button>


      <div
        style={{
          position: 'relative',
          width: this.state.width,
          height: this.state.height,
          background: '#99aabb'
        }}
      >
        <NotifiedBox ref={c => window.c = c} />
        <NotifyResize ref={c => window.a = c} factory={Box} />
      </div>
    </div>
  }
}


render(
  <App />,
  document.getElementById('content') 
)